function [varargout] = promote_and_check (varargin)
  for i = 1 : nargin
    arg = varargin{i};
    if (isa (arg, "gf"))
      m = arg.m;
      p = arg.prim_poly;
      break;
    endif
  endfor
  varargout = cell(1, nargout);
  for i = 1 : nargin
    arg = varargin{i};
    if (! isa (arg, "gf"))
      varargout{i} = gf (arg, m, p);
    else
      if (arg.m != m)
	error ("galois field orders must match");
      endif
      if (arg.prim_poly != p)
	error ("galois field primitive polynomials must match");
      endif
      varargout{i} = arg;
    endif
  endfor
endfunction
